searchNodes=[{"doc":"Various helpers and utilities for working with Ash changesets and queries and phoenix.","ref":"AshPhoenix.html","title":"AshPhoenix","type":"module"},{"doc":"A utility to support &quot;add&quot; buttons on embedded types used in forms.To use, simply pass in the form name of the embedded form as well as the name of the primary/outer form.# In your template, inside a form called `:change` &lt;button phx-click=&quot;append_thing&quot; phx-value-path={{form.path}}&gt; &lt;/button&gt; # In the view/component def handle_event(&quot;append_thing&quot;, %{&quot;path&quot; =&gt; path}, socket) do changeset = add_embed(socket.assigns.changeset, path, &quot;change&quot;) {:noreply, assign(socket, changeset: changeset)} endYou can also pass a specific value to be added, to seed the changes in a customized way. By default, %{} is used.","ref":"AshPhoenix.html#add_embed/4","title":"AshPhoenix.add_embed/4","type":"function"},{"doc":"A utility to support &quot;add&quot; buttons on relationships used in forms.To use, simply pass in the form name of the relationship form as well as the name of the primary/outer form.# In your template, inside a form called `:change` &lt;button phx-click=&quot;append_thing&quot; phx-value-path={{form.path}}&gt; &lt;/button&gt; # In the view/component def handle_event(&quot;append_thing&quot;, %{&quot;path&quot; =&gt; path}, socket) do changeset = add_related(socket.assigns.changeset, path, &quot;change&quot;) {:noreply, assign(socket, changeset: changeset)} endOptions:use_data? - Provide this if you are using use_data? with inputs_for for this relationship The default value is false.:add - the value to add to the relationship The default value is %{}.:relationship - The relationship being updated, in case it can't be determined from the path:id - The value that should be in meta[:id] in the manage changeset opts. Defaults to the relationship name. This only needs to be set if an id is also provided for inputs_for.","ref":"AshPhoenix.html#add_related/4","title":"AshPhoenix.add_related/4","type":"function"},{"doc":"","ref":"AshPhoenix.html#add_to_path/3","title":"AshPhoenix.add_to_path/3","type":"function"},{"doc":"A utility to support &quot;add&quot; buttons on list attributes and arguments used in forms.To use, simply pass in the form name of the attribute/argument form as well as the name of the primary/outer form.# In your template, inside a form called `:change` &lt;button phx-click=&quot;append_thing&quot; phx-value-path={{form.path &lt;&gt; &quot;[attribute_name]&quot;}}&gt; &lt;/button&gt; # In the view/component def handle_event(&quot;append_thing&quot;, %{&quot;path&quot; =&gt; path}, socket) do changeset = add_value(socket.assigns.changeset, path, &quot;change&quot;) {:noreply, assign(socket, changeset: changeset)} endOptions:add - the value to add to the list The default value is nil.","ref":"AshPhoenix.html#add_value/4","title":"AshPhoenix.add_value/4","type":"function"},{"doc":"A utility for decoding the path of a form into a list.For example:change[posts][0][comments][1] [&quot;change&quot;, &quot;posts&quot;, 0, &quot;comments&quot;, 1]","ref":"AshPhoenix.html#decode_path/1","title":"AshPhoenix.decode_path/1","type":"function"},{"doc":"Gets all errors on a changeset or query.This honors the AshPhoenix.FormData.Error protocol and applies any transform_errors. See transform_errors/2 for more information.","ref":"AshPhoenix.html#errors_for/2","title":"AshPhoenix.errors_for/2","type":"function"},{"doc":"","ref":"AshPhoenix.html#hide_errors/1","title":"AshPhoenix.hide_errors/1","type":"function"},{"doc":"","ref":"AshPhoenix.html#hiding_errors?/1","title":"AshPhoenix.hiding_errors?/1","type":"function"},{"doc":"A utility to support &quot;remove&quot; buttons on embedded types used in forms.To use, simply pass in the form name of the embedded form as well as the name of the primary/outer form.# In your template, inside a form called `:change` &lt;button phx-click=&quot;remove_thing&quot; phx-value-path={{form.path}}&gt; &lt;/button&gt; # In the view/component def handle_event(&quot;remove_thing&quot;, %{&quot;path&quot; =&gt; path}, socket) do changeset = remove_embed(socket.assigns.changeset, path, &quot;change&quot;) {:noreply, assign(socket, changeset: changeset)} end","ref":"AshPhoenix.html#remove_embed/3","title":"AshPhoenix.remove_embed/3","type":"function"},{"doc":"A utility to support &quot;remove&quot; buttons on relationships used in forms.To use, simply pass in the form name of the related form as well as the name of the primary/outer form.# In your template, inside a form called `:change` &lt;button phx-click=&quot;remove_thing&quot; phx-value-path={{form.path}}&gt; &lt;/button&gt; # In the view/component def handle_event(&quot;remove_thing&quot;, %{&quot;path&quot; =&gt; path}, socket) do {record, changeset} = remove_related(socket.assigns.changeset, path, &quot;change&quot;) {:noreply, assign(socket, record: record, changeset: changeset)} endOptions:add - the value to add to the relationship, defaults to %{} The default value is %{}.:relationship - The relationship being updated, in case it can't be determined from the path:id - The value that should be in meta[:id] in the manage changeset opts. Defaults to the relationship name. This only needs to be set if an id is also provided for inputs_for.","ref":"AshPhoenix.html#remove_related/4","title":"AshPhoenix.remove_related/4","type":"function"},{"doc":"A utility to support &quot;remove&quot; buttons on list attributes and arguments used in forms.","ref":"AshPhoenix.html#remove_value/3","title":"AshPhoenix.remove_value/3","type":"function"},{"doc":"","ref":"AshPhoenix.html#set_up_relationship_updates/2","title":"AshPhoenix.set_up_relationship_updates/2","type":"function"},{"doc":"Allows for manually transforming errors to modify or enable error messages in the form.By default, only errors that implement the AshPhoenix.FormData.Error protocol will show their errors in forms. This is to protect you from showing strange errors to the user. Using this function, you can intercept those errors (as well as ones that do implement the protocol) and return custom form-ready messages for them.Example:AshPhoenix.transform_errors(changeset, fn changeset, %MyApp.CustomError{message: message} -&gt; {:id, &quot;Something went wrong while doing the %{thing}&quot;, [thing: &quot;request&quot;]} end) # Could potentially be used for translation, although not quite ergonomic yet defp translate_error(key, msg, vars) do if vars[:count] do Gettext.dngettext(MyApp.Gettext, &quot;errors&quot;, msg, msg, count, opts) else Gettext.dgettext(MyApp.Gettext, &quot;errors&quot;, msg, opts) end end AshPhoenix.transform_errors(changeset, fn changeset, %MyApp.CustomError{message: message, field: field} -&gt; translate_error(field, message, [foo: :bar]) changeset, any_error -&gt; if AshPhoenix.FormData.Error.impl_for(any_error) do any_error |&gt; AshPhoenix.FormData.error.to_form_error() |&gt; List.wrap() |&gt; Enum.map(fn {key, msg, vars} -&gt; translate_error(key, msg, vars) end) end end)","ref":"AshPhoenix.html#transform_errors/2","title":"AshPhoenix.transform_errors/2","type":"function"},{"doc":"A module to allow you to fluidly use resources with phoenix forms.The general workflow is, with either liveview or phoenix forms:Create a form with AshPhoenix.FormRender that form with Phoenix's form_for (or, if using surface, &lt;Form&gt;)To validate the form (e.g with on-change for liveview), pass the input to AshPhoenix.Form.validate(form, params)On form submission, pass the input to AshPhoenix.Form.validate(form, params) and then use AshPhoenix.Form.submid(form, ApiModule)If your resource action accepts related data, (for example a managed relationship argument, or an embedded resource attribute), you can use Phoenix's inputs_for for that field, but you must explicitly configure the behavior of it using the forms option. See Form.for_create/3 for more.For example:form = user |&gt; AshPhoenix.Form.for_update(:update, forms: [ profile: [ resource: MyApp.Profile, data: user.profile, create_action: :create, update_action: :update forms: [ emails: [ data: user.profile.emails, resource: MyApp.UserEmail, create_action: :create, update_action: :update ] ] ] ])LiveViewAshPhoenix.Form (unlike ecto changeset based forms) expects to be reused throughout the lifecycle of the liveview.You can use phoenix events to add and remove form entries and submit/2 to submit the form, like so:alias MyApp.MyApi.{Comment, Post} def render(assigns) do ~L&quot;&quot;&quot; &lt;%= f = form_for @form, &quot;#&quot;, [phx_change: :validate, phx_submit: :save] %&gt; &lt;%= label f, :text %&gt; &lt;%= text_input f, :text %&gt; &lt;%= error_tag f, :text %&gt; &lt;%= for comment_form &lt;- inputs_for(f, :comments) do %&gt; &lt;%= hidden_inputs_for(comment_form) %&gt; &lt;%= text_input comment_form, :text %&gt; &lt;%= for sub_comment_form &lt;- inputs_for(comment_form, :sub_comments) do %&gt; &lt;%= hidden_inputs_for(sub_comment_form) %&gt; &lt;%= text_input sub_comment_form, :text %&gt; &lt;button phx-click=&quot;remove_form&quot; phx-value-path=&quot;&lt;%= sub_comment_form.name %&gt;&quot;&gt;Add Comment&lt;/button&gt; &lt;% end %&gt; &lt;button phx-click=&quot;remove_form&quot; phx-value-path=&quot;&lt;%= comment_form.name %&gt;&quot;&gt;Add Comment&lt;/button&gt; &lt;button phx-click=&quot;add_form&quot; phx-value-path=&quot;&lt;%= comment_form.name %&gt;&quot;&gt;Add Comment&lt;/button&gt; &lt;% end %&gt; &lt;button phx-click=&quot;add_form&quot; phx-value-path=&quot;&lt;%= comment_form.name %&gt;&quot;&gt;Add Comment&lt;/button&gt; &lt;%= submit &quot;Save&quot; %&gt; &lt;/form&gt; &quot;&quot;&quot; end def mount(%{&quot;post_id&quot; =&gt; post_id}, _session, socket) do post = Post |&gt; MyApp.MyApi.get!(post_id) |&gt; MyApi.load!(comments: [:sub_comments]) form = AshPhoenix.Form.for_update(post, forms: [ comments: [ resource: Comment, data: post.comments, create_action: :create, update_action: :update forms: [ sub_comments: [ resource: Comment, data: &amp;(&amp;1.sub_comments), create_action: :create, update_action: :update ] ] ] ]) {:ok, assign(socket, form: form)} end def handle_event(&quot;save&quot;, _params, socket) do case AshPhoenix.Form.submit(socket.assigns.form) do {:ok, result} -&gt; # Do something with the result, like redirect {:error, form} -&gt; assign(socket, :form, form) end end def handle_event(&quot;add_form&quot;, %{&quot;path&quot; =&gt; path}, socket) do form = AshPhoenix.Form.add_form(socket.assigns.form, path) {:noreply, assign(socket, :form, form)} end def handle_event(&quot;remove_form&quot;, %{&quot;path&quot; =&gt; path}) do form = AshPhoenix.Form.remove_form(socket.assigns.form, path) {:noreply, assign(socket, :form, form)} end","ref":"AshPhoenix.Form.html","title":"AshPhoenix.Form","type":"module"},{"doc":"Adds a new form at the provided path.Doing this requires that the form has a create_action and a resource configured.path can be one of two things:A list of atoms and integers that lead to a form in the forms option provided. [:posts, 0, :comments] to add a comment to the first post.The html name of the form, e.g form[posts][0][comments] to mimic the above:prepend - If specified, the form is placed at the beginning of the list instead of the end of the list The default value is false.:params - The initial parameters to add the form with. The default value is %{}.","ref":"AshPhoenix.Form.html#add_form/3","title":"AshPhoenix.Form.add_form/3","type":"function"},{"doc":"Creates a form corresponding to a create action on a resource.Options::forms - Nested form configurations. See for_create/3 docs for more.:as - The name of the form in the submitted params. You will need to pull the form params out using this key. The default value is &quot;form&quot;.:id - The html id of the form. The default value is &quot;form&quot;.:transform_errors - Allows for manual manipulation and transformation of errors.If possible, try to implement AshPhoenix.FormData.Error for the error (if it as a custom one, for example). If that isn't possible, you can provide this function which will get the changeset and the error, and should return a list of ash phoenix formatted errors, e.g [{field :: atom, message :: String.t(), substituations :: Keyword.t()}]:method - The http method to associate with the form. Defaults to post for creates, and put for everything else.Any additional options will be passed to the underlying call to Ash.Changeset.for_create/4. This means you can set things like the tenant/actor. These will be retained, and provided again when Form.submit/3 is called.Nested Form Options:type - The cardinality of the nested form. The default value is :single.:forms - Forms nested inside the current nesting level:for - When creating parameters for the action, the key that the forms should be gathered into. Defaults to the key used to configure the nested form.:resource - The resource of the nested forms. Unnecessary if you are providing the data key, and not adding additional forms to this path.:create_action - The create action to use when building new forms. Only necessary if you want to use add_form/3 with this path.:update_action - The update action to use when building forms for data. Only necessary if you supply the data key.:data - The current value or values that should have update forms built by default.You can also provide a single argument function that will return the data based on the data of the parent form. This is important for multiple nesting levels of :list type forms, because the data depends on which parent is being rendered.","ref":"AshPhoenix.Form.html#for_create/3","title":"AshPhoenix.Form.for_create/3","type":"function"},{"doc":"Creates a form corresponding to a destroy action on a record.Options::forms - Nested form configurations. See for_create/3 docs for more.:as - The name of the form in the submitted params. You will need to pull the form params out using this key. The default value is &quot;form&quot;.:id - The html id of the form. The default value is &quot;form&quot;.:transform_errors - Allows for manual manipulation and transformation of errors.If possible, try to implement AshPhoenix.FormData.Error for the error (if it as a custom one, for example). If that isn't possible, you can provide this function which will get the changeset and the error, and should return a list of ash phoenix formatted errors, e.g [{field :: atom, message :: String.t(), substituations :: Keyword.t()}]:method - The http method to associate with the form. Defaults to post for creates, and put for everything else.Any additional options will be passed to the underlying call to Ash.Changeset.for_destroy/4. This means you can set things like the tenant/actor. These will be retained, and provided again when Form.submit/3 is called.","ref":"AshPhoenix.Form.html#for_destroy/3","title":"AshPhoenix.Form.for_destroy/3","type":"function"},{"doc":"Creates a form corresponding to an update action on a record.Options::forms - Nested form configurations. See for_create/3 docs for more.:as - The name of the form in the submitted params. You will need to pull the form params out using this key. The default value is &quot;form&quot;.:id - The html id of the form. The default value is &quot;form&quot;.:transform_errors - Allows for manual manipulation and transformation of errors.If possible, try to implement AshPhoenix.FormData.Error for the error (if it as a custom one, for example). If that isn't possible, you can provide this function which will get the changeset and the error, and should return a list of ash phoenix formatted errors, e.g [{field :: atom, message :: String.t(), substituations :: Keyword.t()}]:method - The http method to associate with the form. Defaults to post for creates, and put for everything else.Any additional options will be passed to the underlying call to Ash.Changeset.for_update/4. This means you can set things like the tenant/actor. These will be retained, and provided again when Form.submit/3 is called.","ref":"AshPhoenix.Form.html#for_update/3","title":"AshPhoenix.Form.for_update/3","type":"function"},{"doc":"Returns the parameters from the form that would be submitted to the action.This can be useful if you want to get the parameters and manipulate them/build a custom changeset afterwards.","ref":"AshPhoenix.Form.html#params/1","title":"AshPhoenix.Form.params/1","type":"function"},{"doc":"A utility for parsing paths of nested forms in query encoded format.For example:parse_path!(form, &quot;post[comments][0][sub_comments][0]) [:comments, 0, :sub_comments, 0]","ref":"AshPhoenix.Form.html#parse_path!/2","title":"AshPhoenix.Form.parse_path!/2","type":"function"},{"doc":"Removes a form at the provided path.See add_form/3 for more information on the path argument.If you are not using liveview, and you want to support removing forms that were created based on the data option from the browser, you'll need to include in the form submission a custom list of strings to remove, and then manually iterate over them in your controller, for example:Enum.reduce(removed_form_paths, form, &amp;AshPhoenix.Form.remove_form(&amp;2, &amp;1))","ref":"AshPhoenix.Form.html#remove_form/2","title":"AshPhoenix.Form.remove_form/2","type":"function"},{"doc":"Submits the form by calling the appropriate function on the provided api.For example, a form created with for_update/3 will call api.update(changeset), where changeset is the result of passing the Form.params/3 into Ash.Changeset.for_update/4.If the submission returns an error, the resulting form can simply be rerendered. Any nested errors will be passed down to the corresponding form for that input.","ref":"AshPhoenix.Form.html#submit/3","title":"AshPhoenix.Form.submit/3","type":"function"},{"doc":"Same as submit/3, but raises an error if the submission fails.","ref":"AshPhoenix.Form.html#submit!/3","title":"AshPhoenix.Form.submit!/3","type":"function"},{"doc":"Validates the parameters against the form.Options::errors - Set to false to hide errors after validation The default value is true.","ref":"AshPhoenix.Form.html#validate/3","title":"AshPhoenix.Form.validate/3","type":"function"},{"doc":"","ref":"AshPhoenix.Form.html#t:t/0","title":"AshPhoenix.Form.t/0","type":"type"},{"doc":"","ref":"AshPhoenix.FormData.Error.html","title":"AshPhoenix.FormData.Error","type":"protocol"},{"doc":"","ref":"AshPhoenix.FormData.Error.html#to_form_error/1","title":"AshPhoenix.FormData.Error.to_form_error/1","type":"function"},{"doc":"","ref":"AshPhoenix.FormData.Error.html#t:t/0","title":"AshPhoenix.FormData.Error.t/0","type":"type"},{"doc":"Utilities for keeping ash query results up to date in a live view.","ref":"AshPhoenix.LiveView.html","title":"AshPhoenix.LiveView","type":"module"},{"doc":"","ref":"AshPhoenix.LiveView.html#can_link_to_page?/2","title":"AshPhoenix.LiveView.can_link_to_page?/2","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#change_page/3","title":"AshPhoenix.LiveView.change_page/3","type":"function"},{"doc":"Incorporates an Ash.Notifier.Notification into the query results, based on the liveness configuration.You will want to match on receiving a notification from Ash, and the easiest way to do that is to match on the payload like so: @impl true def handle_info(%{topic: topic, payload: %Ash.Notifier.Notification{}}, socket) do {:noreply, handle_live(socket, topic, [:query1, :query2, :query3])} endFeel free to intercept notifications and do your own logic to respond to events. Ultimately, all that matters is that you also call handle_live/3 if you want it to update your query results.The assign or list of assigns passed as the third argument must be the same names passed into keep_live. If you only want some queries to update based on some events, you can define multiple matches on events, and only call handle_live/3 with the assigns that should be updated for that notification.","ref":"AshPhoenix.LiveView.html#handle_live/4","title":"AshPhoenix.LiveView.handle_live/4","type":"function"},{"doc":"Runs the callback, and stores the information required to keep it live in the socket assigns.The data will be assigned to the provided key, e.g keep_live(socket, :me, ...) would assign the results to :me (accessed as @me in the template).Additionally, you'll need to define a handle_info/2 callback for your liveview to receive any notifications, and pass that notification into handle_live/3. See handle_live/3 for more.PaginationTo make paginated views convenient, as well as making it possible to keep those views live, Ash does not simply rerun the query when it gets an update, as that could involve shuffling the records around on the page. Eventually this will be configurable, but for now, Ash simply adjusts the query to only include the records that are on the page. If a record would be removed from a page due to a data change, it will simply be left there. For the best performance, use keyset pagination. If you need the ability to jump to a page by number, you'll want to use offset pagination, but keep in mind that it performs worse on large tables.To support this, accept a second parameter to your callback function, which will be the options to use in page_optsOptions::subscribe - A topic or list of topics that should cause this data to update.:refetch? - A boolean flag indicating whether a refetch is allowed to happen. Defaults to true:results - For list and page queries, by default the records shown are never changed (unless the page changes) The default value is :keep.:load_until_connected? - If the socket is not connected, then the value of the provided assign is set to :loading. Has no effect if initial is provided.:initial - Results to use instead of running the query immediately.:api - For paginated views, in order to use change_page/3, you must set the Api to use for pagination:refetch_interval - An interval (in ms) to periodically refetch the query:refetch_window - The minimum time (in ms) between refetches, including refetches caused by notifications.A great way to get readable millisecond values, you can use the functions in erlang's :timer module, like :timer.hours/1, :timer.minutes/1, and :timer.seconds/1refetch_intervalIf this option is set, a message is sent as {:refetch, assign_name, opts} on that interval. You can then match on that event, like so:def handle_info({:refetch, assign, opts}, socket) do {:noreply, handle_live(socket, :refetch, assign, opts)} endThis is the equivalent of :timer.send_interval(interval, {:refetch, assign, opts}), so feel free to roll your own solution if you have complex refetching requirements.refetch_windowNormally, when a pubsub message is received the query is rerun. This option will cause the query to wait at least this amount of time before doing a refetch. This is accomplished with Process.send_after/4, and recording the last time each query was refetched. For example if a refetch happens at time 0, and the refetch_window is 10,000 ms, we would refetch, and record the time. Then if another refetch should happen 5,000 ms later, we would look and see that we need to wait another 5,000ms. So we use Process.send_after/4 to send a {:refetch, assign, opts} message in 5,000ms. The time that a refetch was requested is tracked, so if the data has since been refetched, it won't be refetched again.Future PlansOne interesting thing here is that, given that we know the scope of data that a resource cares about, we should be able to make optimizations to this code, to support partial refetches, or even just updating the data directly. However, this will need to be carefully considered, as the risks involve showing users data they could be unauthorized to see, or having state in the socket that is inconsistent.","ref":"AshPhoenix.LiveView.html#keep_live/4","title":"AshPhoenix.LiveView.keep_live/4","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#last_page/1","title":"AshPhoenix.LiveView.last_page/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#next_page?/1","title":"AshPhoenix.LiveView.next_page?/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#on_page?/2","title":"AshPhoenix.LiveView.on_page?/2","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_from_params/3","title":"AshPhoenix.LiveView.page_from_params/3","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_link_params/2","title":"AshPhoenix.LiveView.page_link_params/2","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_number/1","title":"AshPhoenix.LiveView.page_number/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_params/1","title":"AshPhoenix.LiveView.page_params/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#prev_page?/1","title":"AshPhoenix.LiveView.prev_page?/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:assign/0","title":"AshPhoenix.LiveView.assign/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:assigns/0","title":"AshPhoenix.LiveView.assigns/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:callback/0","title":"AshPhoenix.LiveView.callback/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:callback_result/0","title":"AshPhoenix.LiveView.callback_result/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:liveness_options/0","title":"AshPhoenix.LiveView.liveness_options/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:socket/0","title":"AshPhoenix.LiveView.socket/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:topic/0","title":"AshPhoenix.LiveView.topic/0","type":"type"},{"doc":"This is a basic plug that loads the current tenant assign from a given value set on subdomain.This was copied from Triplex.SubdomainPlug, here: https://github.com/ateliware/triplex/blob/master/lib/triplex/plugs/subdomain_plug.exOptions::endpoint - Required. The endpoint that the plug is in, used for deterining the host:assign - The key to use when assigning the current tenant The default value is :current_tenant.:handle_subdomain - An mfa to call with the conn and a subdomain value. Can be used to do something like fetch the current user given the tenant. Must return the new conn.To plug it on your router, you can use:plug Ash.SubdomainPlug, endpoint: MyApp.EndpointAn additional helper here can be used for determining the host in your liveview, and/or using the host that was already assigned to the conn.For example:def handle_params(params, uri, socket) do socket = assign_new(socket, :current_tenant, fn -&gt; AshPhoenix.SubdomainPlug.live_tenant(socket, uri) end) socket = assign_new(socket, :current_organization, fn -&gt; if socket.assigns[:current_tenant] do MyApp.Accounts.Api.get!(MyApp.Accounts.Organization, subdomain: socket.assigns[:current_tenant] ) end end) {:noreply, socket} end","ref":"AshPhoenix.SubdomainPlug.html","title":"AshPhoenix.SubdomainPlug","type":"module"},{"doc":"","ref":"AshPhoenix.SubdomainPlug.html#live_tenant/2","title":"AshPhoenix.SubdomainPlug.live_tenant/2","type":"function"},{"doc":"","ref":"AshPhoenix.Form.NoActionConfigured.html","title":"AshPhoenix.Form.NoActionConfigured","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"AshPhoenix.Form.NoActionConfigured.html#message/1","title":"AshPhoenix.Form.NoActionConfigured.message/1","type":"function"},{"doc":"","ref":"AshPhoenix.Form.NoDataLoaded.html","title":"AshPhoenix.Form.NoDataLoaded","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"AshPhoenix.Form.NoDataLoaded.html#message/1","title":"AshPhoenix.Form.NoDataLoaded.message/1","type":"function"},{"doc":"","ref":"AshPhoenix.Form.NoFormConfigured.html","title":"AshPhoenix.Form.NoFormConfigured","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"AshPhoenix.Form.NoFormConfigured.html#message/1","title":"AshPhoenix.Form.NoFormConfigured.message/1","type":"function"},{"doc":"","ref":"AshPhoenix.Form.NoResourceConfigured.html","title":"AshPhoenix.Form.NoResourceConfigured","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"AshPhoenix.Form.NoResourceConfigured.html#message/1","title":"AshPhoenix.Form.NoResourceConfigured.message/1","type":"function"},{"doc":"AshPhoenix See the module documentation for more information:AshPhoenix.LiveView: for liveview querying utilitiesAshPhoenix.Form: Utilities for using forms with Ash changesets Roadmap:UI authorization utilities e.g &lt;%= if authorized_to_do?(resource, action, actor) do %&gt;Potentially helpers for easily connecting buttons to resource actionsdef deps do [ {:ash_phoenix, &quot;~&gt; 0.4.23-rc.0&quot;} ] end","ref":"readme.html","title":"AshPhoenix","type":"extras"}]